/************************************************************
*        PROGRAMA DE INICIAO CIENTFICA PIBIC/CNPq        *
*   "Desenvolvimento de uma arquitetura para simulao do   *
*      Funcionamento distribudo e paralelo do crebro"     *
* --------------------------------------------------------- *
*      BOLSISTA: Anderson de Rezende Rocha - DCC/UFLA       *
*       ORIENTADOR: Antnio Maria Pereira de Resende        *
************************************************************/

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import jess.*;

// Tratador de eventos do AgenteCentralizador
// Qualquer interao do usurio com o menu  ouvida
// por esse tratador
class HandlerAgente implements ActionListener
{
   Component componentePai;
   private AgenteCentralizador agente;

   // Construtor pega o componente pai e o chamador da funo
   // para que se tenha ponteiros para os mesmos
   HandlerAgente(Component cpt, AgenteCentralizador ag)
   {
      agente = ag;
      componentePai = cpt;
   }

   // Identifica que tipo de interao ouve entre o usurio e o 
   // menu
   public void actionPerformed(ActionEvent e)
   {
      String comando = e.getActionCommand();

      if (comando.equals("About..."))
      {
         JOptionPane.showMessageDialog(componentePai, "Projeto de Iniciao Cientfica" +
                           " - PIBIC/CNPq\n" + "\nBolsista: Anderson de Rezende Rocha\n" +
                           "Orientador: Antnio Maria Pereira de Resende\n" + 
                           "\nDPTO . DE CINCIA DA COMPUTAO - UFLA, 2001", 
                           "Sobre o projeto", JOptionPane.INFORMATION_MESSAGE);
      }
      else if (comando.equals("Sair"))
      {
         System.exit(0);
      }
      else if (comando.equals("Config..."))
      {
         agente.setCaracteristicas();
         agente.robotsConfigurados = true;
      }
      else if (comando.equals("Criar e executar robots"))
      {
         if (agente.robotsConfigurados)
         {
            agente.robotsConfigurados = false;
            agente.criarRobot();
         }
         else
            JOptionPane.showMessageDialog(componentePai, "Robots ainda no configurados\n" + 
                                         "V em CONFIG para faz-lo!", "Aviso!", 
                                         JOptionPane.WARNING_MESSAGE);
      }
   }
}