/************************************************************
*        PROGRAMA DE INICIAO CIENTFICA PIBIC/CNPq        *
*   "Desenvolvimento de uma arquitetura para simulao do   *
*      Funcionamento distribudo e paralelo do crebro"     *
* --------------------------------------------------------- *
*      BOLSISTA: Anderson de Rezende Rocha - DCC/UFLA       *
*       ORIENTADOR: Antnio Maria Pereira de Resende        *
************************************************************/

import java.awt.Point;
import java.util.Vector;

// Esta classe serve para guardar os componentes 
// que devero ser passados para a rea grfica
public class ContainerEstados
{
   private Point posicao;
   private char face;
   private Point visitado;
   public Vector jaVisitados;
   
   public ContainerEstados()
   {
      posicao = new Point(-1,-1);
      visitado = new Point(-1,-1);
      jaVisitados = new Vector();
   }
   
   public void setFace(char fc)
   {
      face = fc;
   }

   public void setPosicao(Point pos)
   {
      visitado.setLocation(posicao);
      posicao.setLocation(pos);
   }

   public Point getPosicao()
   {
      return posicao;
   }

   public char getFace()
   {
      return face;
   }

   public Point getVisitado()
   {
      return visitado;
   }

   public void adicionarVisitado(Point pto)
   {
      if (jaVisitados.indexOf(pto) == -1)
      {
         jaVisitados.addElement(pto);
      }
   }

   public boolean temVisitado(Point pto)
   {
      for (int i = 0; i < jaVisitados.size(); i++)
      {
         if (jaVisitados.elementAt(i).equals(pto))
         {
            return true;
         }
      }
      return false;
   }
}