/************************************************************
*        PROGRAMA DE INICIAO CIENTFICA PIBIC/CNPq        *    
*   "Desenvolvimento de uma arquitetura para simulao do   *
*      Funcionamento distribudo e paralelo do crebro"     *
* --------------------------------------------------------- *
*      BOLSISTA: Anderson de Rezende Rocha - DCC/UFLA       *
*       ORIENTADOR: Antnio Maria Pereira de Resende        *
************************************************************/

import java.io.*;
import java.net.*;

public class KqmlCliente extends Thread
{
   ObjectOutputStream output;
   ObjectInputStream input;
   String message = "", comando1 = "", comando2 = "";
   String ipServidor;
   int nroPorta;

   public KqmlCliente(String ipServidor, int nroPorta)
   {
        this.ipServidor = ipServidor;
        this.nroPorta = nroPorta;
   }

    public void runClient() 
    {
        Socket client;

        try 
        {
            // Passo 1: Cria um socket para fazer uma conexo
            client = new Socket(InetAddress.getByName(ipServidor), nroPorta);

            // Passo 2: Pega as streams de entrada e sada
            output = new ObjectOutputStream(client.getOutputStream());
            output.flush();
            input = new ObjectInputStream(client.getInputStream());

            // Passo 3: Processa uma conexo
            do 
            {
                try 
                {
                    message = (String) input.readObject();

                    // Local para insero das mensagens
                    sendData(comando1);
                    sendData(comando2);
                }
                catch (ClassNotFoundException cnfex)
                {
                    System.out.println("\nObjeto recebido  desconhecido");
                }
            } while (!message.equals("HALT"));

            // Passo 4: Fecha a conexo
            output.close();
            input.close();
            client.close();
        }
        catch (EOFException eof) 
        {
        }
        catch (IOException e) 
        {
            e.printStackTrace();
        }
    }

    private void sendData(String s)
    {
        try 
        {
            output.writeObject(s);
            output.flush();
        }
        catch ( IOException cnfex )
        {
            System.out.println("\nErro na escrita de objeto" );
        }
    }

    public void enviarMensagem(String r, String s)
    {
        comando1 = r;
        comando2 = s;
    }
}