/************************************************************
*        PROGRAMA DE INICIAO CIENTFICA PIBIC/CNPq        *    
*   "Desenvolvimento de uma arquitetura para simulao do   *
*      Funcionamento distribudo e paralelo do crebro"     *
* --------------------------------------------------------- *
*      BOLSISTA: Anderson de Rezende Rocha - DCC/UFLA       *
*       ORIENTADOR: Antnio Maria Pereira de Resende        *
************************************************************/

import java.io.*;
import java.net.*;
import java.lang.*;
import java.awt.Point;
import java.util.Vector;

public class KqmlServidor extends Thread  
{
    ObjectOutputStream output;
    ObjectInputStream input;
    GUIBot gui;
    Point ptoAcao;
    String comando;
    char face;



    public KqmlServidor(GUIBot g)
    {
        System.out.println("Servidor instanciado");
        gui = g;
    }

    public void runServer()
    {
        ServerSocket server;
        Socket connection;
        int counter = 1;

        try
        {
            // Passo 1 cria um servidor de socket
            // 5000  a porta de conexo
            // 100  o nmero de conexes simultneas
            server = new ServerSocket( 5000, 100 );

            while (true) 
            {
                // Passo 2: Espera por uma conexo
                connection = server.accept();
                
                // Passo 3: Pega streams de entrada e sada
                output = new ObjectOutputStream(connection.getOutputStream());
                output.flush();
                input = new ObjectInputStream(connection.getInputStream());
     
                // Passo 4: Processa conexo
                String message = "";
                output.writeObject(message);
                output.flush();

                do 
                {
                   try 
                   {
                      message = "";
                      message = (String) input.readObject();

                      if (!message.equals("HALT"))
                      {
                          parser(message);
                          gui.executarComando(comando, ptoAcao, face);
                      }

                   }
                   catch (ClassNotFoundException cnfex) 
                   {
                      System.out.println("\nTipo de objeto recebido desconhecido" );
                   }
                } while (!message.equals( "HALT"));

                // Passo 5: Fecha conexo
                output.close();
                input.close();
                connection.close();

                counter++;
            }

        }
        catch (EOFException eof) 
        {
        }
        catch (IOException io) 
        {
            io.printStackTrace();
        }
    }
   
    private void sendData( String s )
    {
        try 
        {
            output.writeObject(s);
            output.flush();
        }
        catch (IOException cnfex) 
        {
            System.out.println("\nErro escrevendo objeto" );
        }
    }

    public void run() 
    {
        runServer();
    }

    private void parser(String m)
    {
        Vector vetorComandos = new Vector();
        KqmlParser kqmlServ = new KqmlParser(m);        
        vetorComandos = kqmlServ.getTokens();
        int x = Integer.parseInt((String)vetorComandos.elementAt(1));
        int y = Integer.parseInt((String)vetorComandos.elementAt(2));
        ptoAcao = new Point (x,y);
        comando = (String)vetorComandos.elementAt(0);
        String fc = (String)vetorComandos.elementAt(4);
        face = fc.charAt(0);
    }
}