/************************************************************
*        PROGRAMA DE INICIAO CIENTFICA PIBIC/CNPq        *
*   "Desenvolvimento de uma arquitetura para simulao do   *
*      Funcionamento distribudo e paralelo do crebro"     *
* --------------------------------------------------------- *
*      BOLSISTA: Anderson de Rezende Rocha - DCC/UFLA       *
*       ORIENTADOR: Antnio Maria Pereira de Resende        *
************************************************************/

// Esta classe  responsvel pela leitura das caractersticas 
// adicionais do ambiente

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class ConfigGraf extends JFrame
{
   private Container c;
   private JLabel labelAvisos;
   private JLabel labelEspera;
   private JLabel labelNumeroObstaculos;
   public JTextField tempoEspera;
   public JTextField status;
   public JButton setupCompleto;
   public JTextField numeroObstaculos;
   // Ponteiro para saber que est sendo configurado
   private GGrafRobotImpl gGraf;
   private int limiteGUI;

   // Construtor default quando chamado cria um painel 
   // onde sero lidos as caractersticas do ambiente
   public ConfigGraf(GGrafRobotImpl graf, int limiteGUI)
   {
      super("Configurando o ambiente e os ROBOTs");
      
      gGraf = graf;
      this.limiteGUI = limiteGUI;
      c = getContentPane();
      c.setLayout(new FlowLayout());

      labelAvisos = new JLabel("Menu de Cofiguraes!");
      labelEspera = new JLabel("Tempo de espera (mili-segundos)");
      labelNumeroObstaculos = new JLabel("Numero de obstaculos...");
      tempoEspera = new JTextField(10);
      numeroObstaculos = new JTextField(10);
      status = new JTextField(45);
      setupCompleto = new JButton("<< Retornar <<");

      status.setEditable(false);
      status.setFont(new Font("Courier", Font.ITALIC + Font.BOLD, 11));
      status.setBackground(Color.green);

      numeroObstaculos.setEnabled(false);
      setupCompleto.setEnabled(false);
      
      labelAvisos.setText("Ao digitar uma opo pressione ENTER");
      
      // Anexando os ouvintes da GUI que servem para ouvir qualquer modificao 
      // no estado de um desses componentes
      tempoEspera.addActionListener(new HandlerConfigGraf(this));
      setupCompleto.addActionListener(new HandlerConfigGraf(this));
      numeroObstaculos.addActionListener(new HandlerConfigGraf(this));
      
      // Anexando componentes ao container grfico
      c.add(labelAvisos); 
      c.add(labelEspera);
      c.add(tempoEspera);
      c.add(labelNumeroObstaculos);
      c.add(numeroObstaculos);
      c.add(status);
      c.add(setupCompleto);
      
      // Janela de configurao tem tamanho fixo
      setResizable(false);
      setSize(400, 180);
      show();
   }

   // Seta o tempo de espera. Este tempo  o tempo entre uma deliberao 
   // e outra pelos robots. Quanto maior o tempo mais lenta a execuo das
   // tarefas passadas
   public void setTempoEspera(long tempo)
   {
      gGraf.setTempoEspera(tempo);
   }

   public void setObstaculo(Point pto)
   {
      gGraf.adicionarObstaculo(pto);
   }
   
   public int getLimite()
   {
      return limiteGUI;
   }

   public void setAmbienteConfigurado(boolean op)
   {
      gGraf.setupCompleto = op;
   }
}